#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

#define N_MAX 5

int main(int argc, char** argv) {
    int root = 0;
    MPI_Init(NULL, NULL);

    int world_rank, world_size;
    MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);
    MPI_Comm_size(MPI_COMM_WORLD, &world_size);

    // Inizializzo array
    int my_array[world_size][N_MAX];
    for (int i = 0; i < world_size; i++) {
        for (int j = 0; j < N_MAX; j++) {
            my_array[i][j] = j + i;
        }
    }

    int part_sum = 0;
    for (int i = 0; i < N_MAX; i++) {
        part_sum += my_array[world_rank][i];
    }
    printf("La somma parziale del nodo %d è: %d\n", world_rank, part_sum);
    //MPI_Barrier(MPI_COMM_WORLD);
    if (world_rank != root) {
        MPI_Send(&part_sum, 1, MPI_INT, root, 0, MPI_COMM_WORLD);
    } else {
        int temp_sum = 0;
        int sum = 0;
        int count = 0;
        while(count < (world_size - 1)) {
            MPI_Recv(&temp_sum, 1, MPI_INT, MPI_ANY_SOURCE, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
            sum += temp_sum;
            count++;
        }
        sum += part_sum;
        printf("La somma totale è: %d\n", sum);
    }

    MPI_Finalize();
}